<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\DF\Modules\Saida\Services\Dfs88000ConhecimentoTransporteEletronicoService;


class Dfs88000ConhecimentoTransporteEletronicoController extends \Teknisa\DF\Controllers\TeknisaCrud {
    const NOVO_CODIGO_LANC_CTE = "CDCTE";
    
    protected $Dfs88000ConhecimentoTransporteEletronicoService;
    protected $novoCodigo;
    protected $environment;
    
    public function __construct($crudService, ParameterBag $parameterBag, Dfs88000ConhecimentoTransporteEletronicoService $Dfs88000ConhecimentoTransporteEletronicoService, $novoCodigo, $environment) {
        $this->Dfs88000ConhecimentoTransporteEletronicoService = $Dfs88000ConhecimentoTransporteEletronicoService;
        $this->novoCodigo = $novoCodigo;
        $this->environment = $environment;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function getDefaultFilterCTE(Request\Row $request, Response $response) {
        $row = $request->getRow();
        
        $defaultFilter = $this->Dfs88000ConhecimentoTransporteEletronicoService->getDefaultFilterCTE($row);
        
        $response->addDataset(new \Zeedhi\Framework\DataSource\DataSet('defaultFilter', $defaultFilter));
    }
    
    public function getDefaultCte(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $cdEmpresa = isset($row["CDEMPRESA"]) ? $row["CDEMPRESA"] : '';
        $cdInscesta = isset($row["CDINSCESTA"]) ? $row["CDINSCESTA"] : ''; 
        
        $cte = $this->Dfs88000ConhecimentoTransporteEletronicoService->getDefaultCte($cdEmpresa, $cdInscesta);
        
        $response->addDataset(new \Zeedhi\Framework\DataSource\DataSet('cte', $cte));
    
    }
    
    public function salvarCte(Request\Row $request, Response $response) {
        $row = $request->getRow();
        
        if($row["__is_new"] === true) {
            //Adquire o sequencial
            $row["CDCTE"] = $this->novoCodigo->getCodeByTableName(self::NOVO_CODIGO_LANC_CTE.$row["CDEMPRESA"], $this->environment->getNrOrgTrab());
            
            //Versão do processo
            $row["IDVERPROCESSO"] = "TEK_MOBILE";
            
            //Inicializa os totais
            $row["VRTOTAPRESTSERV"] = 0;
            $row["VRTOTARECEBER"] = 0;
            
            //TODO: Implementar campos abaixo
            $row["CDPRODUTO"] = "0000003945";
            $row["DSPRODPREDOMINA"] = "teste";
        }
        //Limite máximo do campo
        $row["DSNATUOPERACAO"] = substr($row["DSNATUOPERACAO"], 0, 60);
        
        $this->dataSourceName = "cte";
        parent::save($request, $response);
        
        $row["__is_new"] = false;
        $response->addMessage(new Response\Message($row));
    }
}